# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "asmkit-rs"
version = "0.3.0"
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "Portable assembler toolkit: decoding and encoding of various architectures"
readme = "README.md"
keywords = [
    "assembler",
    "asm",
    "jit",
    "riscv",
    "x86",
]
license = "MIT OR Apache-2.0"
repository = "https://codeberg.org/playXE/asmkit"

[features]
aarch64 = []
default = [
    "x86",
    "riscv",
    "aarch64",
    "jit",
]
jit = [
    "wasmtime-jit-icache-coherence",
    "libc",
    "errno",
]
riscv = []
x86 = []
x86-asm = ["x86-dyn"]
x86-dyn = ["x86"]

[lib]
name = "asmkit"
path = "src/lib.rs"

[[example]]
name = "a64"
path = "examples/a64.rs"

[[example]]
name = "factorial"
path = "examples/factorial.rs"

[[example]]
name = "reloc"
path = "examples/reloc.rs"

[[bench]]
name = "x86"
path = "benches/x86.rs"
harness = false

[dependencies.bitflags]
version = "2.11.0"

[dependencies.cfgenius]
version = "0.1"

[dependencies.errno]
version = "0.3.9"
optional = true
default-features = false

[dependencies.intrusive-collections]
version = "0.9"

[dependencies.libc]
version = "0.2.162"
optional = true
default-features = false

[dependencies.num-traits]
version = "0.2.19"
default-features = false

[dependencies.paste]
version = "1.0"

[dependencies.smallvec]
version = "1.13"

[dev-dependencies.capstone]
version = "0.14.0"

[dev-dependencies.criterion]
version = "0.5"
features = ["html_reports"]

[dev-dependencies.iced-x86]
version = "1.21"
features = ["code_asm"]

[target.'cfg(target_arch="riscv64")'.dependencies.wasmtime-jit-icache-coherence]
version = "26.0.1"
optional = true

[profile.release]
panic = "abort"
